function a3_sa ( x0 )
% A3_SA - Verfahren des Steilsten Abstiegs
%
% Synopsis:
%    a3_sa ( x0 )
%
% Return values:
%    (none)
%
% 2001-02-06, Stephan Engelke, Andreas Meister


maxiter = 1000;
%example_1				% load constants, etc.
%example_2				% load constants, etc.

% $$$ B = [  1  1  1 1; 
% $$$       -1  1  1 1;
% $$$        1 -1  1 1;
% $$$        1  1 -1 1 ];
% $$$ 
% $$$ D = [ 1 12 25 17 ];
% $$$ A = B'*diag(D)*B;
% $$$ 
% $$$ b = [ 1 1 1 1 ]';

% $$$ A  = [ 2 0 ; 0 10 ];
% $$$ b  = [ 0; 0];
% $$$ x0 = [ 4; sqrt(1.8) ];

n   = size (A, 1);

eps = 1e-14;
r   = zeros ( n, 1 );
k   = 0;
x   = x0;

while ( k < maxiter )
  r = b - A * x;
  res2 = norm ( r );			% Default is || . ||_2
  
  if (res2 > eps)
    lambda = res2^2 / (r' * (A*r));
  else
    break;
  end
  
  fprintf ('%4i\t%21.12e\n', k, res2);

  x = x + lambda * r;
  k = k + 1;
end

fprintf ('%4i\t%21.12e\n', k, res2);
